#include<avr/io.h>
#include<util/delay.h>
/*Code for a flickering candle project*/
/*LED Anode to Vcc */
/*Set max current to be 30 mA for each LED*/
/*LFSR Source: http://en.wikipedia.org/wiki/Linear_feedback_shift_register*/

/*OCR0A = red*/
/*OCR0B = green*/
/*ORC1A = blue*/

#define BRIGHT_MAX_R 250
#define BRIGHT_MAX_G 250
#define BRIGHT_MAX_B 0

#define BRIGHT_MIN_R 120
#define BRIGHT_MIN_G 40
#define BRIGHT_MIN_B 0

#define F_CPU 20000000



/* PWM Init function
*/
void pwm_init()
{
OCR0A = 0;					// off
OCR0B = 0;				 	//
DDRB |= 0x18;
DDRD |= 0xF0;       		// Set port D bit 5 as output was 0x20
TCCR0A = 0xA1;          	// 8-bit, non-inverted PWM on OC0A & OC0B (was 0xf1)
TCCR0B = 1;             	// Start PWM

TCCR1A = 0xA1; //non inverted pwm (was 1)
TCCR1B = 1;
OCR1A= 0xff00 | 0x00;       //off
}


void self_test()
{
int i;

 set_rgb(250,0,0);
 _delay_ms(4000);
 set_rgb(0,250,0);
 _delay_ms(4000);
 set_rgb(0,0,250);
 _delay_ms(4000);

for(i=0;i<255;i++)
{
set_rgb(i,i,i);
_delay_ms(100);
}
for(i=0;i<255;i++)
{
set_rgb(255-i,255-i,255-i);
_delay_ms(10);
}
}

/* This function sets the colors of the RGB LED to the requested values using the PWM
** features of the AVR
*/
void set_rgb(int rx, int gx, int bx)
{
OCR0A=rx;    		//8 bit timer, output A
OCR0B=gx;			//8 bit timer, output B
OCR1A= 0xff00 | bx;  //on ATTIny2313 timer 1 is 16 bit, so use just a piece of it
}

/* This function fades from rgb1 to rgb2 */
/*
void fade_rgb(int r1, int g1, int b1, int r2, int g2, int b2, int numsteps,int dly_ms)
{
int delta_r, delta_g, delta_b;
int i;

delta_r=(r2-r1) / numsteps;
delta_g=(g2-g1) / numsteps;
delta_b=(b2-b1) / numsteps;

for (i=0;i<=numsteps; i++)
{
 set_rgb( (r1 + i * delta_r),
 		  (g1 + i * delta_g),
		  (b1 + i * delta_b));
 _delay_ms(dly_ms);
}

set_rgb(r2,g2,b2);
}
*/

main()
 {
unsigned long lfsr = 1,t0=0,t1=0,t2=0,t3=0;
unsigned char temp;

pwm_init();  // setup the PWM features

self_test();  //run a quick test of the LED.


for(;;)
 {
   lfsr = (lfsr >> 1) ^ (-(lfsr & 1u) & 0xd0000001u); /* taps 32 31 29 1 */
temp = (unsigned char) lfsr;


t1= temp & 0x01;
t2= (temp & 0x02)>>1;
t3 = (temp & 0x04)>>2;

t0 = t1 | t2 | t3;

if (t0==0) 
	{
		set_rgb(BRIGHT_MIN_R, BRIGHT_MIN_G, BRIGHT_MIN_B);
		  //fade_rgb(BRIGHT_MAX_R, BRIGHT_MAX_G, BRIGHT_MAX_B, 
		  //		   BRIGHT_MIN_R, BRIGHT_MIN_G, BRIGHT_MIN_B,10,2);

	} 
	else 
	{
		set_rgb(BRIGHT_MAX_R, BRIGHT_MAX_G,BRIGHT_MAX_B);
		//  fade_rgb(BRIGHT_MIN_R, BRIGHT_MIN_G, BRIGHT_MIN_B,
		//  		   BRIGHT_MAX_R, BRIGHT_MAX_G, BRIGHT_MAX_B, 10, 2);

	}; 

temp = (unsigned char) (lfsr >> 24);
_delay_loop_2(250*temp);
//_delay_loop_2(temp<<6);
 } 

 }
